diff -aur otp_src_R8B_2002-07-21/erts/emulator/beam/beam_emu.c otp_src_R8B_2002-07-21.fixed/erts/emulator/beam/beam_emu.c
--- otp_src_R8B_2002-07-21/erts/emulator/beam/beam_emu.c	Wed Apr 10 15:40:44 2002
+++ otp_src_R8B_2002-07-21.fixed/erts/emulator/beam/beam_emu.c	Mon Jul 22 14:10:56 2002
@@ -44,12 +44,20 @@
 #  define CountCase(OpCode) case op_count_##OpCode
 #  define OpCode(OpCode)    ((Uint*)op_##OpCode)
 #  define Goto(Rel) {Go = (int)(Rel); goto emulator_loop;}
-#  define LabelAddr(Addr) &&##Addr
+#  ifdef __GNUC__
+#    define LabelAddr(Addr) &&Addr
+#  else
+#    define LabelAddr(Addr) &&##Addr
+#  endif
 #else
 #  define OpCase(OpCode)    lb_##OpCode
 #  define CountCase(OpCode) lb_count_##OpCode
 #  define Goto(Rel) goto *(Rel)
-#  define LabelAddr(Addr) &&##Addr
+#  ifdef __GNUC__
+#    define LabelAddr(Addr) &&Addr
+#  else
+#    define LabelAddr(Addr) &&##Addr
+#  endif
 #  define OpCode(OpCode)  (&&lb_##OpCode)
 #endif
 
diff -aur otp_src_R8B_2002-07-21/erts/emulator/beam/erl_bits.c otp_src_R8B_2002-07-21.fixed/erts/emulator/beam/erl_bits.c
--- otp_src_R8B_2002-07-21/erts/emulator/beam/erl_bits.c	Wed Apr 10 15:43:08 2002
+++ otp_src_R8B_2002-07-21.fixed/erts/emulator/beam/erl_bits.c	Mon Jul 22 14:09:39 2002
@@ -35,7 +35,13 @@
 #define BYTE_OFFSET(ofs) ((unsigned) (ofs) >> 3)
 #define BIT_OFFSET(ofs) ((ofs) & 7)
 
+#ifdef MAX
+#undef MAX
+#endif
 #define MAX(x,y) (((x)>(y))?(x):(y))
+#ifdef MIN
+#undef MIN
+#endif
 #define MIN(x,y) (((x)<(y))?(x):(y))
 
 #if defined(WORDS_BIGENDIAN)
diff -aur otp_src_R8B_2002-07-21/erts/etc/unix/run_erl.c otp_src_R8B_2002-07-21.fixed/erts/etc/unix/run_erl.c
--- otp_src_R8B_2002-07-21/erts/etc/unix/run_erl.c	Tue Jul 16 12:28:09 2002
+++ otp_src_R8B_2002-07-21.fixed/erts/etc/unix/run_erl.c	Mon Jul 22 14:13:16 2002
@@ -41,6 +41,7 @@
 #include <signal.h>
 #include <dirent.h>
 #include <termios.h>
+#include <time.h>
 
 #define noDEBUG
 
diff -aur otp_src_R8B_2002-07-21/lib/erl_interface/src/decode_big.c otp_src_R8B_2002-07-21.fixed/lib/erl_interface/src/decode_big.c
--- otp_src_R8B_2002-07-21/lib/erl_interface/src/decode_big.c	Tue Jul 16 14:50:17 2002
+++ otp_src_R8B_2002-07-21.fixed/lib/erl_interface/src/decode_big.c	Mon Jul 22 14:20:41 2002
@@ -18,6 +18,7 @@
 #include <string.h>
 #include "ei.h"
 #include "putget.h"
+#include "erl_malloc.h"
 
 extern int ei_decode_big(const char *buf, int *index, erlang_big *b)
 {
diff -aur otp_src_R8B_2002-07-21/lib/erl_interface/src/ei_connect.c otp_src_R8B_2002-07-21.fixed/lib/erl_interface/src/ei_connect.c
--- otp_src_R8B_2002-07-21/lib/erl_interface/src/ei_connect.c	Thu Oct 11 17:03:32 2001
+++ otp_src_R8B_2002-07-21.fixed/lib/erl_interface/src/ei_connect.c	Mon Jul 22 14:26:46 2002
@@ -69,6 +69,7 @@
 #include <arpa/inet.h>
 #include <netdb.h>
 #include <sys/utsname.h>  /* for gen_challenge (NEED FIX?) */
+#include <time.h>
 #endif
 
 /* common includes */
@@ -1278,7 +1279,9 @@
     char *buf, *s;
     char dbuf[DEFBUF_SIZ];
     int siz = 2 + 1 + 2 + 4 + strlen(nodename);
+#ifdef DEBUG_DIST
     const char* function[] = {"SEND_NAME", "SEND_CHALLENGE"};
+#endif
     if (f_chall)
 	siz += 4;
     buf = (siz > DEFBUF_SIZ) ? malloc(siz) : dbuf;
diff -aur otp_src_R8B_2002-07-21/lib/erl_interface/src/ei_pthreads.c otp_src_R8B_2002-07-21.fixed/lib/erl_interface/src/ei_pthreads.c
--- otp_src_R8B_2002-07-21/lib/erl_interface/src/ei_pthreads.c	Mon Oct  8 11:03:17 2001
+++ otp_src_R8B_2002-07-21.fixed/lib/erl_interface/src/ei_pthreads.c	Mon Jul 22 14:29:09 2002
@@ -41,6 +41,7 @@
 #endif
 
 #include "erl_error.h"
+#include "ei_connect.h"
 
 extern int erl_locking_init_done;
 
diff -aur otp_src_R8B_2002-07-21/lib/erl_interface/src/erl_call.c otp_src_R8B_2002-07-21.fixed/lib/erl_interface/src/erl_call.c
--- otp_src_R8B_2002-07-21/lib/erl_interface/src/erl_call.c	Tue Aug 22 14:14:53 2000
+++ otp_src_R8B_2002-07-21.fixed/lib/erl_interface/src/erl_call.c	Mon Jul 22 14:22:00 2002
@@ -66,6 +66,7 @@
 #include <sys/socket.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
+#include <time.h>
 #endif
 
 #include <stdio.h>
diff -aur otp_src_R8B_2002-07-21/lib/erl_interface/src/send_exit.c otp_src_R8B_2002-07-21.fixed/lib/erl_interface/src/send_exit.c
--- otp_src_R8B_2002-07-21/lib/erl_interface/src/send_exit.c	Mon Oct  8 10:44:18 2001
+++ otp_src_R8B_2002-07-21.fixed/lib/erl_interface/src/send_exit.c	Mon Jul 22 14:24:07 2002
@@ -37,7 +37,7 @@
 #include <string.h>
 #include <stdlib.h>
 #include "ei.h"
-#include "erl_connect.h"
+#include "ei_connect.h"
 #include "putget.h"
 
 #ifdef __WIN32__
diff -aur otp_src_R8B_2002-07-21/lib/megaco/src/flex/Makefile.in otp_src_R8B_2002-07-21.fixed/lib/megaco/src/flex/Makefile.in
--- otp_src_R8B_2002-07-21/lib/megaco/src/flex/Makefile.in	Fri May 17 13:06:09 2002
+++ otp_src_R8B_2002-07-21.fixed/lib/megaco/src/flex/Makefile.in	Mon Jul 22 15:52:50 2002
@@ -140,7 +140,7 @@
 CFLAGS += -DMFS_DEBUG=true
 endif
 
-CFLAGS += $(DRIVER_INCLUDES) $(DRV_FLAGS) -funroll-loops -Wall 
+CFLAGS += $(DRIVER_INCLUDES) $(DRV_FLAGS) -funroll-loops -Wall -Wno-unused 
 
 ifeq ($(ENABLE_MEGACO_FLEX_SCANNER_LINENO),true)
 LEX_FLAGS = -Ca
diff -aur otp_src_R8B_2002-07-21/lib/orber/c_src/inet.h otp_src_R8B_2002-07-21.fixed/lib/orber/c_src/inet.h
--- otp_src_R8B_2002-07-21/lib/orber/c_src/inet.h	Thu Oct 21 15:35:06 1999
+++ otp_src_R8B_2002-07-21.fixed/lib/orber/c_src/inet.h	Mon Jul 22 14:37:39 2002
@@ -36,4 +36,4 @@
 #define SERVICE "oiad"
 #define PROTO "tcp"
 
-#endif _inet_h
+#endif /* _inet_h */
diff -aur otp_src_R8B_2002-07-21/lib/ssl/c_src/debuglog.h otp_src_R8B_2002-07-21.fixed/lib/ssl/c_src/debuglog.h
--- otp_src_R8B_2002-07-21/lib/ssl/c_src/debuglog.h	Mon Sep 20 22:51:32 1999
+++ otp_src_R8B_2002-07-21.fixed/lib/ssl/c_src/debuglog.h	Mon Jul 22 14:41:39 2002
@@ -26,9 +26,15 @@
 #include <stdio.h>
 #include "esock_ssl.h"
 
+#ifdef __GNUC__
+#define DEBUGF(x)  if (debug) __debugprintf x;
+#define DEBUGMSGF(x)  if (debugmsg) __debugprintclistf x;
+#define LOGF(fp, x) if (fp) { __locallogfp = fp; __debuglogf x; }
+#else
 #define DEBUGF(x)  if (debug) __debugprintf ## x;
 #define DEBUGMSGF(x)  if (debugmsg) __debugprintclistf ## x;
 #define LOGF(fp, x) if (fp) { __locallogfp = fp; __debuglogf ## x; }
+#endif
 #define SSLDEBUGF()  if (debug) { esock_ssl_print_errors_fp(stderr); \
     if (syslogfp) esock_ssl_print_errors_fp(syslogfp); }
 
diff -aur otp_src_R8B_2002-07-21/lib/ssl/c_src/esock_ssleay.c otp_src_R8B_2002-07-21.fixed/lib/ssl/c_src/esock_ssleay.c
--- otp_src_R8B_2002-07-21/lib/ssl/c_src/esock_ssleay.c	Thu Jun  6 13:43:04 2002
+++ otp_src_R8B_2002-07-21.fixed/lib/ssl/c_src/esock_ssleay.c	Mon Jul 22 15:41:52 2002
@@ -74,6 +74,29 @@
 #include "ssl.h"
 #include "err.h"
 
+/*
+** Compatibility hack for different SSL versions 
+** Unfortunately there is no define in OpenSSL to tell 
+** the version installed.
+** The esock_ssleay.c module is dependent of two changes:
+** a) pem_password_cb userdata appeares in 0.9.4 and later
+** b) malloc/realloc pointers returned are void * in 0.9.5 and later
+**
+**/
+#ifndef OPENSSL_VERSION
+  /* SSL_CTRL_MODE appeared in 0.9.4 */
+  #ifndef SSL_CTRL_MODE 
+    #define OPENSSL_VERSION 0x000903 /* or earlier */
+  #else
+    /* The SSL_AD_USER_CANCLED was changed to SSL_AD_USER_CANCELLED in 0.9.5 */
+    #ifndef SSL_AD_USER_CANCELLED
+      #define OPENSSL_VERSION 0x000904
+    #else
+      #define OPENSSL_VERSION 0x000905 /* or later */
+    #endif
+  #endif
+#endif
+
 char *esock_ssl_err_str = "";
 
 #define FLAGSBUFSIZE		512
@@ -93,7 +116,11 @@
 static void maybe_set_err_str(char *s);
 static int set_ssl_parameters(Connection *cp, int server);
 static int verify_callback(int ok, X509_STORE_CTX *ctx);
+#if OPENSSL_VERSION < 0x000904
 static int passwd_callback(char *buf, int num, int verify);
+#else
+static int passwd_callback(char *buf, int num, int verify, void *userdata);
+#endif
 static void info_callback(SSL *s, int where, int ret);
 
 static err_entry errs[] = {    
@@ -122,9 +149,15 @@
      * Silly casts to avoid compiler warnings: malloc and realloc in 
      * SSLeay should return void * and not char *.  
      */
+#if OPENSSL_VERSION < 0x000905
     CRYPTO_set_mem_functions((char *(*)())esock_malloc, 
 			     (char *(*)())esock_realloc, 
 			     esock_free);
+#else
+    CRYPTO_set_mem_functions((void *(*)())esock_malloc, 
+			     (void *(*)())esock_realloc, 
+			     esock_free);
+#endif
     meth = SSLv23_method();
     SSL_load_error_strings();
     SSLeay_add_ssl_algorithms();
@@ -820,7 +853,11 @@
     return ok;
 }
 
+#if OPENSSL_VERSION < 0x000904
 static int passwd_callback(char *buf, int num, int verify)
+#else
+static int passwd_callback(char *buf, int num, int verify, void *userdata)
+#endif
 {
     int len;
     if (key_passwd) {
